> For the complete documentation index, see [llms.txt](https://docs.efento.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.efento.io/nb-iot-loggers/integrations/efento-coap-loader/api-reference/models.md).

# Models

## The Measurement object

```json
{"openapi":"3.0.3","info":{"title":"CoAP Loader API Documentation","version":"3.0.0"},"components":{"schemas":{"Measurement":{"type":"object","required":["serial","battery","signal","measured_at","measurement_interval","next_measurement_at","params"],"properties":{"serial":{"type":"string","description":"Unique serial number of the sensor"},"battery":{"type":"string","description":"Battery level status","enum":["ok","low"]},"signal":{"type":"integer","description":"Signal quality indicator based on RSSI (0-63)","minimum":0,"maximum":63},"measured_at":{"type":"string","description":"UTC date and time of the measurement"},"measurement_interval":{"type":"integer","description":"The interval between measurements in seconds"},"next_measurement_at":{"type":"string","description":"The scheduled UTC time for the next connection"},"params":{"type":"array","description":"A list of measured physical parameters.\n\n**Note:** This array may be empty if all sensor channels are of type NO_SENSOR (unconfigured/disabled channels).\nThe CoAP Loader automatically filters out NO_SENSOR channels before forwarding data to your API.\n","items":{"$ref":"#/components/schemas/MeasurementParam"}}}},"MeasurementParam":{"type":"object","required":["channel","type","value","status"],"properties":{"channel":{"type":"integer","description":"The sensor channel number","minimum":1,"maximum":6},"type":{"type":"string","description":"The Measurement Type","enum":["temperature","humidity","pressure","pressure_diff","open-close","iaq","flooding","pulse_counter","electricity_usage","water_usage","soil_moisture","co_gas","no2_gas","h2s_gas","ambient_light","pm_1_0","pm_2_5","pm_10_0","noise_level","nh3_gas","ch4_gas","high_pressure","distance_mm","water_meter_acc","co2_gas","humidity_accurate","static_iaq","co2_equivalent","breath_voc","percentage","voltage","current","electricity_meter_acc","output_control","shared_modem"]},"value":{"oneOf":[{"type":"string"},{"type":"number"}],"description":"The actual value recorded for this measurement"},"status":{"type":"string","description":"Indicates reading health","enum":["ok","error"]}}}}}}
```

## The MeasurementParam object

```json
{"openapi":"3.0.3","info":{"title":"CoAP Loader API Documentation","version":"3.0.0"},"components":{"schemas":{"MeasurementParam":{"type":"object","required":["channel","type","value","status"],"properties":{"channel":{"type":"integer","description":"The sensor channel number","minimum":1,"maximum":6},"type":{"type":"string","description":"The Measurement Type","enum":["temperature","humidity","pressure","pressure_diff","open-close","iaq","flooding","pulse_counter","electricity_usage","water_usage","soil_moisture","co_gas","no2_gas","h2s_gas","ambient_light","pm_1_0","pm_2_5","pm_10_0","noise_level","nh3_gas","ch4_gas","high_pressure","distance_mm","water_meter_acc","co2_gas","humidity_accurate","static_iaq","co2_equivalent","breath_voc","percentage","voltage","current","electricity_meter_acc","output_control","shared_modem"]},"value":{"oneOf":[{"type":"string"},{"type":"number"}],"description":"The actual value recorded for this measurement"},"status":{"type":"string","description":"Indicates reading health","enum":["ok","error"]}}}}}}
```

## The SensorConfiguration object

```json
{"openapi":"3.0.3","info":{"title":"CoAP Loader API Documentation","version":"3.0.0"},"components":{"schemas":{"SensorConfiguration":{"type":"object","required":["serialNumber","timestamp","partsCount","partIndex","hash","parameters"],"properties":{"serialNumber":{"type":"string","description":"Unique serial number of the sensor"},"timestamp":{"type":"string","description":"Data timestamp"},"partsCount":{"type":"integer","description":"Total number of parts the configuration is divided into","minimum":1},"partIndex":{"type":"integer","description":"Index of the currently transmitted configuration part","minimum":1},"hash":{"type":"string","description":"Configuration hash (changes with every setting update).\n**Important:** If hash = \"0\", the sensor runs deprecated software and cannot receive configuration updates.\n"},"parameters":{"type":"array","description":"Current sensor settings. For detailed specification of all available parameter types and validation rules, see **ConfigurationParametersReference** in the Models section.\n\nMost commonly used types: MEASUREMENT_PERIOD, TRANSMISSION_INTERVAL, ACK_INTERVAL, SERVER_DATA, APN, PLMN, CLOUD_TOKEN, RULE_1-12, RULE_CALENDAR_1-6.\n","items":{"$ref":"#/components/schemas/SensorParameter"}}}},"SensorParameter":{"type":"object","required":["type","settings"],"properties":{"type":{"type":"string","description":"The unique name of the parameter. Available types include:\nACK_INTERVAL, APN, BANDS, BLE_TURNOFF_TIME, BLE_TX_POWER_LEVEL,\nCELLULAR_CONFIG, CLOUD_TOKEN, CLOUD_TOKEN_COAP_OPTION,\nCONFIGURATION_ENDPOINT, DATA_ENDPOINT, DEVICE_INFO_ENDPOINT,\nDNS_SERVER, DNS_TTL_CONFIG, ENCRYPTION_KEY, LED_CONFIG,\nMEASUREMENT_PERIOD, NETWORK_TROUBLESHOOTING,\nPAYLOAD_SIGNATURE_COAP_OPTION, PLMN, REQUEST_DISABLE_MODEM,\nSERVER_DATA, SERVER_UPDATE, SUPERVISION_PERIOD, TIME_ENDPOINT,\nTRANSMISSION_INTERVAL, TRANSFER_LIMIT, TRANSFER_LIMIT_TIMER,\nCALIBRATION, RULE_1 through RULE_12, RULE_CALENDAR_1 through RULE_CALENDAR_6\n\nFor detailed specification of each parameter type, including required fields and validation rules, see **ConfigurationParametersReference** in the Models section.\n"},"settings":{"type":"object","description":"A nested object containing specific key-value pairs for that parameter","additionalProperties":true}}}}}}
```

## The SensorParameter object

```json
{"openapi":"3.0.3","info":{"title":"CoAP Loader API Documentation","version":"3.0.0"},"components":{"schemas":{"SensorParameter":{"type":"object","required":["type","settings"],"properties":{"type":{"type":"string","description":"The unique name of the parameter. Available types include:\nACK_INTERVAL, APN, BANDS, BLE_TURNOFF_TIME, BLE_TX_POWER_LEVEL,\nCELLULAR_CONFIG, CLOUD_TOKEN, CLOUD_TOKEN_COAP_OPTION,\nCONFIGURATION_ENDPOINT, DATA_ENDPOINT, DEVICE_INFO_ENDPOINT,\nDNS_SERVER, DNS_TTL_CONFIG, ENCRYPTION_KEY, LED_CONFIG,\nMEASUREMENT_PERIOD, NETWORK_TROUBLESHOOTING,\nPAYLOAD_SIGNATURE_COAP_OPTION, PLMN, REQUEST_DISABLE_MODEM,\nSERVER_DATA, SERVER_UPDATE, SUPERVISION_PERIOD, TIME_ENDPOINT,\nTRANSMISSION_INTERVAL, TRANSFER_LIMIT, TRANSFER_LIMIT_TIMER,\nCALIBRATION, RULE_1 through RULE_12, RULE_CALENDAR_1 through RULE_CALENDAR_6\n\nFor detailed specification of each parameter type, including required fields and validation rules, see **ConfigurationParametersReference** in the Models section.\n"},"settings":{"type":"object","description":"A nested object containing specific key-value pairs for that parameter","additionalProperties":true}}}}}}
```

## The DeviceInfo object

```json
{"openapi":"3.0.3","info":{"title":"CoAP Loader API Documentation","version":"3.0.0"},"components":{"schemas":{"DeviceInfo":{"type":"object","required":["serialNumber","softwareVersion","commitId","cloudToken","memoryStatistics","updateTimestamp","updateStatus"],"properties":{"serialNumber":{"type":"string","description":"Unique serial number of the sensor"},"softwareVersion":{"type":"string","description":"Current firmware version"},"runtimeInfo":{"$ref":"#/components/schemas/RuntimeInfo"},"modemInfo":{"$ref":"#/components/schemas/ModemInfo"},"commitId":{"type":"string","description":"Unique identifier of the specific software build"},"cloudToken":{"type":"string","description":"Unique token used for cloud authentication"},"memoryStatistics":{"type":"array","description":"A list of numbers representing internal memory usage/allocation","items":{"type":"integer"}},"updateTimestamp":{"type":"integer","format":"int64","description":"The timestamp of the last firmware or configuration update"},"updateStatus":{"type":"integer","description":"Numeric code representing the status of the last update attempt"}}},"RuntimeInfo":{"type":"object","description":"Diagnostic data regarding the device's stability and power","properties":{"uptime":{"type":"integer","description":"Total seconds the device has been running since the last boot"},"confirmableMessagesAttempts":{"type":"integer","description":"(Optional) Number of attempts to send messages requiring an ACK"},"nonConfirmableMessagesAttempts":{"type":"integer","description":"(Optional) Number of attempts to send messages without an ACK"},"succeededMessages":{"type":"integer","description":"(Optional) Number of messages successfully delivered to the platform"},"mcuTemperature":{"type":"integer","description":"Current temperature of the processor in Celsius"},"minBatteryVoltage":{"type":"integer","description":"Minimum recorded battery voltage in mV"},"minBatteryMcuTemperature":{"type":"integer","description":"Processor temperature at the time the minimum battery voltage was recorded"},"batteryResetTimestamp":{"type":"integer","format":"int64","description":"Unix timestamp of the last battery replacement or manual reset (Polish00)"},"maxMcuTemperature":{"type":"integer","description":"Highest recorded processor temperature in Celsius"},"minMcuTemperature":{"type":"integer","description":"Lowest recorded processor temperature in Celsius"},"runtimeErrors":{"type":"array","description":"A list of internal system error codes (max length 20)","items":{"type":"integer"}}}},"ModemInfo":{"type":"object","description":"Low-level parameters from the cellular modem, crucial for analyzing network performance.\n\n## Modem Info Parameters\n\nThe `parameters` array contains 34 numeric values representing detailed network and modem diagnostics (for BC66 modem type).\nEach index in the array corresponds to a specific parameter:\n\n| Index | Parameter Name | Description | Range | Unknown Value |\n|-------|----------------|-------------|-------|---------------|\n| 0 | sc_EARFCN | Serving cell E-UTRA Absolute Radio Frequency Channel Number | [0:262143] | -1 |\n| 1 | sc_EARNFCN_offset | Serving cell frequency offset (mapped to [-2, -1, -0.5, 0, 1]) | [0:4] | -1 |\n| 2 | sc_PCI | Serving cell Physical Cell ID | [0:502] | -1 |\n| 3 | sc_Cell_id | Serving cell ID | [1:268435456] | 0 |\n| 4 | sc_RSRP | Serving cell Reference Signal Received Power [dBm] | [-140:-44] | 0 |\n| 5 | sc_RSRQ | Serving cell Reference Signal Received Quality [dB] | [-20:-3] | 0 |\n| 6 | sc_RSSI | Serving cell Received Signal Strength Indicator [dBm] | [-110:-3] | 0 |\n| 7 | sc_SINR | Serving cell Signal to Interference plus Noise Ratio [dB] | [-10:30] | 31 |\n| 8 | sc_Band | The current serving cell band | [see module supported bands] | -1 |\n| 9 | sc_TAC | Serving cell Tracking Area Code | [0:65536] | -1 |\n| 10 | sc_ECL | Serving cell Extended Coverage Level | [0:2] | -1 |\n| 11 | sc_TX_PWR | Serving cell Transmit Power [0.1cBm] | [-440:230] | -1000 |\n| 12 | OP_MODE | Operation Mode | [0:3] | -1 |\n| 13 | nc_EARFCN | Neighbor cell E-UTRA Absolute Radio Frequency Channel Number | [0:262143] | -1 |\n| 14 | nc_EARNFCN_offset | Neighbor cell frequency offset (mapped to [-2, -1, -0.5, 0, 1]) | [0:4] | -1 |\n| 15 | nc_PCI | Neighbor cell Physical Cell ID | [0:502] | -1 |\n| 16 | nc_RSRP | Neighbor cell Reference Signal Received Power [dBm] | [-140:-44] | 0 |\n| 17 | RLC_UL_BLER | Radio Link Control Uplink Block Error Rate | [0:100] | -1 |\n| 18 | RLC_DL_BLER | Radio Link Control Downlink Block Error Rate | [0:100] | -1 |\n| 19 | MAC_UL_BLER | Medium Access Control Uplink Block Error Rate | [0:100] | -1 |\n| 20 | MAC_DL_BLER | Medium Access Control Downlink Block Error Rate | [0:100] | -1 |\n| 21 | MAC_UL_TOTAL_BYTES | Medium Access Control Uplink Total Bytes | [0:2147483647] | -1 |\n| 22 | MAC_DL_TOTAL_BYTES | Medium Access Control Downlink Total Bytes | [0:2147483647] | -1 |\n| 23 | MAC_UL_total_HARQ_Tx | Medium Access Control Uplink Total HARQ Transmissions | [0:2147483647] | -1 |\n| 24 | MAC_DL_total_HARQ_Tx | Medium Access Control Downlink Total HARQ Transmissions | [0:2147483647] | -1 |\n| 25 | MAC_UL_HARQ_re_Tx | Medium Access Control Uplink HARQ Retransmissions | [0:2147483647] | -1 |\n| 26 | MAC_DL_HARQ_re_Tx | Medium Access Control Downlink HARQ Retransmissions | [0:2147483647] | -1 |\n| 27 | RLC_UL_tput | Radio Link Control Uplink Throughput | [0:2147483647] | -1 |\n| 28 | RLC_DL_tput | Radio Link Control Downlink Throughput | [0:2147483647] | -1 |\n| 29 | MAC_UL_tput | Medium Access Control Uplink Throughput | [0:2147483647] | -1 |\n| 30 | MAC_DL_tput | Medium Access Control Downlink Throughput | [0:2147483647] | -1 |\n| 31 | sleep_duration | Sleep Duration [0.1s] | [0:2147483647] | -1 |\n| 32 | Rx_time | Receive Time [0.1s] | [0:2147483647] | -1 |\n| 33 | Tx_time | Transmit Time [0.1s] | [0:2147483647] | -1 |\n\n**Note:** \"Unknown value\" indicates the value used when the parameter is unavailable or not applicable.\n","properties":{"modemType":{"type":"string","description":"The model identification of the modem","enum":["MODEM_TYPE_UNSPECIFIED","MODEM_TYPE_BC66","MODEM_TYPE_BC66NA","MODEM_TYPE_SHARED_MODEM","MODEM_TYPE_BC660"]},"parameters":{"type":"array","description":"An array of 34 numeric values representing network quality and modem diagnostics (for BC66 modem). See the table above for detailed parameter descriptions.","items":{"type":"integer"}}}}}}}
```

## The RuntimeInfo object

```json
{"openapi":"3.0.3","info":{"title":"CoAP Loader API Documentation","version":"3.0.0"},"components":{"schemas":{"RuntimeInfo":{"type":"object","description":"Diagnostic data regarding the device's stability and power","properties":{"uptime":{"type":"integer","description":"Total seconds the device has been running since the last boot"},"confirmableMessagesAttempts":{"type":"integer","description":"(Optional) Number of attempts to send messages requiring an ACK"},"nonConfirmableMessagesAttempts":{"type":"integer","description":"(Optional) Number of attempts to send messages without an ACK"},"succeededMessages":{"type":"integer","description":"(Optional) Number of messages successfully delivered to the platform"},"mcuTemperature":{"type":"integer","description":"Current temperature of the processor in Celsius"},"minBatteryVoltage":{"type":"integer","description":"Minimum recorded battery voltage in mV"},"minBatteryMcuTemperature":{"type":"integer","description":"Processor temperature at the time the minimum battery voltage was recorded"},"batteryResetTimestamp":{"type":"integer","format":"int64","description":"Unix timestamp of the last battery replacement or manual reset (Polish00)"},"maxMcuTemperature":{"type":"integer","description":"Highest recorded processor temperature in Celsius"},"minMcuTemperature":{"type":"integer","description":"Lowest recorded processor temperature in Celsius"},"runtimeErrors":{"type":"array","description":"A list of internal system error codes (max length 20)","items":{"type":"integer"}}}}}}}
```

## The ModemInfo object

```json
{"openapi":"3.0.3","info":{"title":"CoAP Loader API Documentation","version":"3.0.0"},"components":{"schemas":{"ModemInfo":{"type":"object","description":"Low-level parameters from the cellular modem, crucial for analyzing network performance.\n\n## Modem Info Parameters\n\nThe `parameters` array contains 34 numeric values representing detailed network and modem diagnostics (for BC66 modem type).\nEach index in the array corresponds to a specific parameter:\n\n| Index | Parameter Name | Description | Range | Unknown Value |\n|-------|----------------|-------------|-------|---------------|\n| 0 | sc_EARFCN | Serving cell E-UTRA Absolute Radio Frequency Channel Number | [0:262143] | -1 |\n| 1 | sc_EARNFCN_offset | Serving cell frequency offset (mapped to [-2, -1, -0.5, 0, 1]) | [0:4] | -1 |\n| 2 | sc_PCI | Serving cell Physical Cell ID | [0:502] | -1 |\n| 3 | sc_Cell_id | Serving cell ID | [1:268435456] | 0 |\n| 4 | sc_RSRP | Serving cell Reference Signal Received Power [dBm] | [-140:-44] | 0 |\n| 5 | sc_RSRQ | Serving cell Reference Signal Received Quality [dB] | [-20:-3] | 0 |\n| 6 | sc_RSSI | Serving cell Received Signal Strength Indicator [dBm] | [-110:-3] | 0 |\n| 7 | sc_SINR | Serving cell Signal to Interference plus Noise Ratio [dB] | [-10:30] | 31 |\n| 8 | sc_Band | The current serving cell band | [see module supported bands] | -1 |\n| 9 | sc_TAC | Serving cell Tracking Area Code | [0:65536] | -1 |\n| 10 | sc_ECL | Serving cell Extended Coverage Level | [0:2] | -1 |\n| 11 | sc_TX_PWR | Serving cell Transmit Power [0.1cBm] | [-440:230] | -1000 |\n| 12 | OP_MODE | Operation Mode | [0:3] | -1 |\n| 13 | nc_EARFCN | Neighbor cell E-UTRA Absolute Radio Frequency Channel Number | [0:262143] | -1 |\n| 14 | nc_EARNFCN_offset | Neighbor cell frequency offset (mapped to [-2, -1, -0.5, 0, 1]) | [0:4] | -1 |\n| 15 | nc_PCI | Neighbor cell Physical Cell ID | [0:502] | -1 |\n| 16 | nc_RSRP | Neighbor cell Reference Signal Received Power [dBm] | [-140:-44] | 0 |\n| 17 | RLC_UL_BLER | Radio Link Control Uplink Block Error Rate | [0:100] | -1 |\n| 18 | RLC_DL_BLER | Radio Link Control Downlink Block Error Rate | [0:100] | -1 |\n| 19 | MAC_UL_BLER | Medium Access Control Uplink Block Error Rate | [0:100] | -1 |\n| 20 | MAC_DL_BLER | Medium Access Control Downlink Block Error Rate | [0:100] | -1 |\n| 21 | MAC_UL_TOTAL_BYTES | Medium Access Control Uplink Total Bytes | [0:2147483647] | -1 |\n| 22 | MAC_DL_TOTAL_BYTES | Medium Access Control Downlink Total Bytes | [0:2147483647] | -1 |\n| 23 | MAC_UL_total_HARQ_Tx | Medium Access Control Uplink Total HARQ Transmissions | [0:2147483647] | -1 |\n| 24 | MAC_DL_total_HARQ_Tx | Medium Access Control Downlink Total HARQ Transmissions | [0:2147483647] | -1 |\n| 25 | MAC_UL_HARQ_re_Tx | Medium Access Control Uplink HARQ Retransmissions | [0:2147483647] | -1 |\n| 26 | MAC_DL_HARQ_re_Tx | Medium Access Control Downlink HARQ Retransmissions | [0:2147483647] | -1 |\n| 27 | RLC_UL_tput | Radio Link Control Uplink Throughput | [0:2147483647] | -1 |\n| 28 | RLC_DL_tput | Radio Link Control Downlink Throughput | [0:2147483647] | -1 |\n| 29 | MAC_UL_tput | Medium Access Control Uplink Throughput | [0:2147483647] | -1 |\n| 30 | MAC_DL_tput | Medium Access Control Downlink Throughput | [0:2147483647] | -1 |\n| 31 | sleep_duration | Sleep Duration [0.1s] | [0:2147483647] | -1 |\n| 32 | Rx_time | Receive Time [0.1s] | [0:2147483647] | -1 |\n| 33 | Tx_time | Transmit Time [0.1s] | [0:2147483647] | -1 |\n\n**Note:** \"Unknown value\" indicates the value used when the parameter is unavailable or not applicable.\n","properties":{"modemType":{"type":"string","description":"The model identification of the modem","enum":["MODEM_TYPE_UNSPECIFIED","MODEM_TYPE_BC66","MODEM_TYPE_BC66NA","MODEM_TYPE_SHARED_MODEM","MODEM_TYPE_BC660"]},"parameters":{"type":"array","description":"An array of 34 numeric values representing network quality and modem diagnostics (for BC66 modem). See the table above for detailed parameter descriptions.","items":{"type":"integer"}}}}}}}
```

## The ConfigurationResponse object

```json
{"openapi":"3.0.3","info":{"title":"CoAP Loader API Documentation","version":"3.0.0"},"components":{"schemas":{"ConfigurationResponse":{"type":"object","description":"Response body to remotely change the sensor's settings","properties":{"parameters":{"type":"array","description":"List of parameters to update on the sensor","items":{"$ref":"#/components/schemas/SensorParameter"}}}},"SensorParameter":{"type":"object","required":["type","settings"],"properties":{"type":{"type":"string","description":"The unique name of the parameter. Available types include:\nACK_INTERVAL, APN, BANDS, BLE_TURNOFF_TIME, BLE_TX_POWER_LEVEL,\nCELLULAR_CONFIG, CLOUD_TOKEN, CLOUD_TOKEN_COAP_OPTION,\nCONFIGURATION_ENDPOINT, DATA_ENDPOINT, DEVICE_INFO_ENDPOINT,\nDNS_SERVER, DNS_TTL_CONFIG, ENCRYPTION_KEY, LED_CONFIG,\nMEASUREMENT_PERIOD, NETWORK_TROUBLESHOOTING,\nPAYLOAD_SIGNATURE_COAP_OPTION, PLMN, REQUEST_DISABLE_MODEM,\nSERVER_DATA, SERVER_UPDATE, SUPERVISION_PERIOD, TIME_ENDPOINT,\nTRANSMISSION_INTERVAL, TRANSFER_LIMIT, TRANSFER_LIMIT_TIMER,\nCALIBRATION, RULE_1 through RULE_12, RULE_CALENDAR_1 through RULE_CALENDAR_6\n\nFor detailed specification of each parameter type, including required fields and validation rules, see **ConfigurationParametersReference** in the Models section.\n"},"settings":{"type":"object","description":"A nested object containing specific key-value pairs for that parameter","additionalProperties":true}}}}}}
```

## The ConfigurationParametersReference object

```json
{"openapi":"3.0.3","info":{"title":"CoAP Loader API Documentation","version":"3.0.0"},"components":{"schemas":{"ConfigurationParametersReference":{"type":"object","description":"# Configuration Parameters Reference\n\nThis section provides complete documentation for all available configuration parameters that can be:\n- Received in the `/configuration` endpoint (current sensor settings)\n- Returned in the `/measurements` response (to remotely update sensor settings)\n\n## Available Configuration Parameters\n\nThe following table describes all available configuration parameters:\n\n| [type] | [settings - key] | [settings - value for key] |\n|--------|------------------|----------------------------|\n| **ACK_INTERVAL** | mode* | ALWAYS / CUSTOM |\n| | interval (with mode CUSTOM only) | Integer [180 - 2592000 sec] |\n| **APN** | mode* | AUTO / CUSTOM |\n| | apn (with mode CUSTOM only) | String [max 49 characters] |\n| | apnUsername | String [max 31 characters] |\n| | apnPassword | String [max 31 characters] |\n| **BANDS** | bands* | String (integers separated by comma) example: '1,2,3' [1, 2, 3, 4, 5, 6, 8, 12, 13, 17, 18, 19, 20, 25, 26, 28, 66, 71, 85] |\n| **BLE_TURNOFF_TIME** | mode* | ALWAYS_ON / CUSTOM |\n| | time (with mode CUSTOM only) | Integer [60 - 604800 sec] |\n| **BLE_TX_POWER_LEVEL** | level* | Integer [1 - 4] |\n| **CELLULAR_CONFIG** | parameters* | String (integers separated by comma, without size - index 0) max number of integers: 11, example: '1,2,3' |\n| **CLOUD_TOKEN** | mode* | DISABLED / CUSTOM / IMEI |\n| | token (with mode CUSTOM only) | String [max 255 chars] |\n| **CLOUD_TOKEN_COAP_OPTION** | mode* | AUTO / CUSTOM |\n| | optionId (with mode CUSTOM only) | Integer [1 - 65000] |\n| **CONFIGURATION_ENDPOINT** | endpoint | String [max 16 characters] |\n| **DATA_ENDPOINT** | endpoint | String [max 16 characters] |\n| **DEVICE_INFO_ENDPOINT** | endpoint | String [max 16 characters] |\n| **DNS_SERVER** | ip | String [valid ip address] (e.g., 192.168.1.1) |\n| **DNS_TTL_CONFIG** | mode* | ACCEPT_TTL_FROM_DNS / AFTER_COMMUNICATION_FAILED / CUSTOM |\n| | ttl (with mode CUSTOM only) | Integer [1 - 864000]  |\n| **ENCRYPTION_KEY** | key* | String [max 16 characters] |\n| **LED_CONFIG** | parameters* | String (integers separated by comma) example: '1,2,3' |\n| **MEASUREMENT_PERIOD** | period* | Integer [1 - 65535] |\n| **NETWORK_TROUBLESHOOTING** | mode* | DISABLED / ENABLED] |\n| **PAYLOAD_SIGNATURE_COAP_OPTION** | mode* | AUTO / CUSTOM |\n| | optionId (with mode CUSTOM only) | Integer [1 - 65000] |\n| **PLMN** | mode* | AUTO / CUSTOM |\n| | time (with mode CUSTOM only) | Integer [100 - 999999] |\n| **REQUEST_DISABLE_MODEM** | time* | Integer [180 - 604800] |\n| **SERVER_DATA** | ip* | String [valid ip address] (e.g., 192.168.1.1) |\n| | port* | Integer [1 - 65535] |\n| **SERVER_UPDATE** | ip* | String [valid ip address] (e.g., 192.168.1.1) |\n| | portCoap* | Integer [1 - 65535] |\n| | portUdp* | Integer [1 - 65535] |\n| **SUPERVISION_PERIOD** | mode* | DISABLED / CUSTOM |\n| | period (with mode CUSTOM only) | Integer [180 - 604800] |\n| **TIME_ENDPOINT** | endpoint* | String [max 16 characters] |\n| **TRANSMISSION_INTERVAL** | interval* | Integer [60 - 604800 sec] |\n| **TRANSFER_LIMIT** | mode* | DISABLED / CUSTOM |\n| | time (with mode CUSTOM only) | Integer [180 - 65534] |\n| **TRANSFER_LIMIT_TIMER** | mode* | DISABLED / CUSTOM |\n| | time (with mode CUSTOM only) | Integer [180 - 65534] |\n| **CALIBRATION** | channelNumbers* | String (integers seperated by comma, no duplicates) example: '1,2,3' [1 - 6] |\n| | channelAssignment* | Integer |\n| | parameters* | String (integers seperated by comma, max number of integers: 8) example: '1,2,3' |\n| **RULE_1** to **RULE_12** | condition* | HIGH_THRESHOLD, LOW_THRESHOLD, DIFF_THRESHOLD, BINARY_CHANGE_STATE, LOGIC_OPERATOR, ON_MEASUREMENT, DISABLED |\n| | action* | ACTION_TRIGGER_TRANSMISSION, ACTION_NO_ACTION, ACTION_TRIGGER_TRANSMISSION_WITH_ACK - Required for: HIGH_THRESHOLD, LOW_THRESHOLD, DIFF_THRESHOLD, BINARY_CHANGE_STATE, LOGIC_OPERATOR, ON_MEASUREMENT. (Not present when condition = DISABLED) |\n| | type* | Required for: HIGH_THRESHOLD, LOW_THRESHOLD, DIFF_THRESHOLD. Not used for: BINARY_CHANGE_STATE, LOGIC_OPERATOR, ON_MEASUREMENT, DISABLED |\n| | channelNumbers* | String (integers separated by comma, no duplicates) example: '1,2,3' [1 - 6] |\n| | | Required for: HIGH_THRESHOLD, LOW_THRESHOLD, DIFF_THRESHOLD, BINARY_CHANGE_STATE. Not used for: LOGIC_OPERATOR, ON_MEASUREMENT, DISABLED |\n| | threshold* | Float - required for: HIGH_THRESHOLD, LOW_THRESHOLD, DIFF_THRESHOLD |\n| | hysteresis* | Float - required for: HIGH_THRESHOLD, LOW_THRESHOLD. Not used for: DIFF_THRESHOLD |\n| | averageMode* | MOVING_AVERAGE, WINDOW_MODE, CONSECUTIVE_SAMPLES - required for: HIGH_THRESHOLD, LOW_THRESHOLD, DIFF_THRESHOLD |\n| | averageNumberOfSamples* | Integer [1 - 10] - required for: HIGH_THRESHOLD, LOW_THRESHOLD, DIFF_THRESHOLD |\n| | logicOperator* | AND, OR - required for: LOGIC_OPERATOR |\n| | selectedRules* | String (integers separated by comma, no duplicates) example: '1,2,3' [1 - 12] - required for: LOGIC_OPERATOR. Optional for: ON_MEASUREMENT |\n| | actionDelay* | Integer [0 - 864000] - required for: LOGIC_OPERATOR |\n| | returnDelay* | Integer [0 - 864001] - required for: LOGIC_OPERATOR |\n| | negatedRules | String (integers separated by comma, no duplicates) example: '1,2,3' [1 - 12] - optional for: LOGIC_OPERATOR, ON_MEASUREMENT |\n| | measurementTransmission* | Integer [1 - 500] - required for: ON_MEASUREMENT |\n| **RULE_CALENDAR_1** to **RULE_CALENDAR_6** | type* | DISABLED, WEEK |\n| | selectedRules* | String (integers separated by comma, no duplicates) example: '1,2,3' [1 - 12] (required for WEEK, not present when DISABLED) |\n| | from* | Integer (minutes from midnight) [0 - 1439] (required for WEEK, not present when DISABLED) |\n| | to* | Integer (minutes from midnight) [0 - 1439] (required for WEEK, not present when DISABLED) |\n| | timezone* | Integer (number of 15 minute offsets) [-48 - 56] (required for WEEK, not present when DISABLED) |\n| | days* | String (enums separated by comma) example: 'MONDAY, SATURDAY' - allowed: MONDAY, TUESDAY, WEDNESDAY, THURSDAY, FRIDAY, SATURDAY, SUNDAY (required for WEEK, not present when DISABLED) |\n\n**Note:** Fields marked with * are required for the given parameter type.\n\n## Threshold Ranges for Rules\n\nThe following table describes valid threshold and hysteresis ranges for different measurement types used in Rule conditions:\n\n| Type | Threshold Range | Hysteresis Range | Resolution |\n|------|-----------------|------------------|-----------|\n| **TEMPERATURE** | -273.2 – 4000.0 | 0.0 – 4273.2 | 0.1 |\n| **HUMIDITY** | 0.0 – 100.0 | 0.0 – 100.0 | 1.0 |\n| **ATMOSPHERIC_PRESSURE** | 1.0 – 2000.0 | 0.0 – 1999.0 | 0.1 |\n| **DIFFERENTIAL_PRESSURE** | -10000.0 – 10000.0 | 0.0 – 20000.0 | 1.0 |\n| **IAQ** | 0.0 – 500.0 | 0.0 – 500.0 | 1.0 |\n| **PULSE_CNT, WATER_METER** | 0.0 – 8000000.0 | 0.0 – 8000000.0 | 1.0 |\n| **ELECTRICITY_METER** | 0.0 – 8000000.0 | 0.0 – 8000000.0 | 1.0 |\n| **SOIL_MOISTURE** | -1000.0 – 0.0 | 0.0 – 1000.0 | 1.0 |\n| **CO_GAS, NO2_GAS** | 0.0 – 1000000.0 | 0.0 – 1000000.0 | 1.0 |\n| **H2S_GAS** | 0.0 – 80000.0 | 0.0 – 800000.0 | 0.01 |\n| **AMBIENT_LIGHT** | 0.0 – 100000.0 | 0.0 – 1000000.0 | 0.1 |\n| **PM_1_0, PM_2_5, PM_10_0** | 0.0 – 1000.0 | 0.0 – 1000.0 | 1.0 |\n| **NOISE_LEVEL** | 0.0 – 200.0 | 0.0 – 200.0 | 0.1 |\n| **NH3_GAS, CH4_GAS** | 0.0 – 1000000.0 | 0.0 – 1000000.0 | 1.0 |\n| **HIGH_PRESSURE** | 0.0 – 2000000.0 | 0.0 – 2000000.0 | 1.0 |\n| **DISTANCE_MM** | 0.0 – 1000000.0 | 0.0 – 1000000.0 | 1.0 |\n| **WATER_METER_ACCUMULATIVE** | 0.0 – 1000000.0 | 0.0 – 1000000.0 | 0.001 |\n| **CO2_GAS, CO2_EQUIVALENT** | 0.0 – 1000000.0 | 0.0 – 1000000.0 | 1.0 |\n| **HUMIDITY_ACCURATE** | 0.0 – 100.0 | 0.0 – 100.0 | 0.1 |\n| **STATIC_IAQ** | 0.0 – 10000.0 | 0.0 – 10000.0 | 1.0 |\n| **BREATH_VOC** | 0.0 – 1000000.0 | 0.0 – 1000000.0 | 1.0 |\n| **PERCENTAGE** | 0.0 – 100.0 | 0.0 – 100.0 | 0.01 |\n| **VOLTAGE** | 0.0 – 1000000.0 | 0.0 – 1000000.0 | 0.1 |\n| **CURRENT** | 0.0 – 100000.0 | 0.0 – 100000.0 | 0.01 |\n| **PULSE_COUNTER_ACCUMULATIVE** | 0.0 – 10010000000.0 | 0.0 – 10010000000.0 | 1.0 |\n| **PULSE_COUNTER_ACCUMULATIVE_WIDE** | 0 – 999 999 999 999 | 0 – 999 999 999 999 | 1.0 |\n| **ELECTRICITY_METER_ACC** | 0.0 – 10010000.0 | 0.0 – 10010000.0 | 0.001 |\n| **CURRENT_PRECISE** | -4000.0 – 4000.0 | 0.0 – 4000.0 | 0.001 |\n| **RESISTANCE** | 0.0 – 1000000.0 | 0.0 – 1000000.0 | 1.0 |\n\n**Note:** Fields marked with * are required for the given parameter type.\n\n## Required Fields by Rule Condition\n\nThe following table shows exactly which settings fields are required or optional for each rule condition type:\n\n| Condition | Required Fields | Optional Fields |\n|-----------|----------------|-----------------|\n| **HIGH_THRESHOLD** | condition, action, type, channelNumbers, threshold, hysteresis, averageMode, averageNumberOfSamples | — |\n| **LOW_THRESHOLD** | condition, action, type, channelNumbers, threshold, hysteresis, averageMode, averageNumberOfSamples | — |\n| **DIFF_THRESHOLD** | condition, action, type, channelNumbers, threshold, averageMode, averageNumberOfSamples | — |\n| **BINARY_CHANGE_STATE** | condition, action, channelNumbers | — |\n| **LOGIC_OPERATOR** | condition, action, logicOperator, selectedRules, actionDelay, returnDelay | negatedRules |\n| **ON_MEASUREMENT** | condition, action, measurementTransmission | selectedRules, negatedRules |\n| **DISABLED** | condition | — |\n\n## Threshold Ranges for Rules\n\nThe following table describes valid threshold and hysteresis ranges for different measurement types used in Rule conditions:\n\n| Type | Threshold Range | Hysteresis Range | Resolution |\n|------|-----------------|------------------|-----------|\n| **TEMPERATURE** | -273.2 – 4000.0 | 0.0 – 4273.2 | 0.1 |\n| **HUMIDITY** | 0.0 – 100.0 | 0.0 – 100.0 | 1.0 |\n| **ATMOSPHERIC_PRESSURE** | 1.0 – 2000.0 | 0.0 – 1999.0 | 0.1 |\n| **DIFFERENTIAL_PRESSURE** | -10000.0 – 10000.0 | 0.0 – 20000.0 | 1.0 |\n| **IAQ** | 0.0 – 500.0 | 0.0 – 500.0 | 1.0 |\n| **PULSE_CNT, WATER_METER** | 0.0 – 8000000.0 | 0.0 – 8000000.0 | 1.0 |\n| **ELECTRICITY_METER** | 0.0 – 8000000.0 | 0.0 – 8000000.0 | 1.0 |\n| **SOIL_MOISTURE** | -1000.0 – 0.0 | 0.0 – 1000.0 | 1.0 |\n| **CO_GAS, NO2_GAS** | 0.0 – 1000000.0 | 0.0 – 1000000.0 | 1.0 |\n| **H2S_GAS** | 0.0 – 80000.0 | 0.0 – 800000.0 | 0.01 |\n| **AMBIENT_LIGHT** | 0.0 – 100000.0 | 0.0 – 1000000.0 | 0.1 |\n| **PM_1_0, PM_2_5, PM_10_0** | 0.0 – 1000.0 | 0.0 – 1000.0 | 1.0 |\n| **NOISE_LEVEL** | 0.0 – 200.0 | 0.0 – 200.0 | 0.1 |\n| **NH3_GAS, CH4_GAS** | 0.0 – 1000000.0 | 0.0 – 1000000.0 | 1.0 |\n| **HIGH_PRESSURE** | 0.0 – 2000000.0 | 0.0 – 2000000.0 | 1.0 |\n| **DISTANCE_MM** | 0.0 – 1000000.0 | 0.0 – 1000000.0 | 1.0 |\n| **WATER_METER_ACCUMULATIVE** | 0.0 – 1000000.0 | 0.0 – 1000000.0 | 0.001 |\n| **CO2_GAS, CO2_EQUIVALENT** | 0.0 – 1000000.0 | 0.0 – 1000000.0 | 1.0 |\n| **HUMIDITY_ACCURATE** | 0.0 – 100.0 | 0.0 – 100.0 | 0.1 |\n| **STATIC_IAQ** | 0.0 – 10000.0 | 0.0 – 10000.0 | 1.0 |\n| **BREATH_VOC** | 0.0 – 1000000.0 | 0.0 – 1000000.0 | 1.0 |\n| **PERCENTAGE** | 0.0 – 100.0 | 0.0 – 100.0 | 0.01 |\n| **VOLTAGE** | 0.0 – 1000000.0 | 0.0 – 1000000.0 | 0.1 |\n| **CURRENT** | 0.0 – 100000.0 | 0.0 – 100000.0 | 0.01 |\n| **PULSE_COUNTER_ACCUMULATIVE** | 0.0 – 10010000000.0 | 0.0 – 10010000000.0 | 1.0 |\n| **PULSE_COUNTER_ACCUMULATIVE_WIDE** | 0 – 999 999 999 999 | 0 – 999 999 999 999 | 1.0 |\n| **ELECTRICITY_METER_ACC** | 0.0 – 10010000.0 | 0.0 – 10010000.0 | 0.001 |\n| **CURRENT_PRECISE** | -4000.0 – 4000.0 | 0.0 – 4000.0 | 0.001 |\n| **RESISTANCE** | 0.0 – 1000000.0 | 0.0 – 1000000.0 | 1.0 |\n"}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.efento.io/nb-iot-loggers/integrations/efento-coap-loader/api-reference/models.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
